/* gcalccmd.c generated by valac 0.26.0.50-d9a75, the Vala compiler
 * generated from gcalccmd.vala, do not modify */

/*
 * Copyright (C) 2009 Rich Burridge
 * Copyright (C) 2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <langinfo.h>
#include <stdio.h>
#include <locale.h>


#define TYPE_SERIALIZER (serializer_get_type ())
#define SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SERIALIZER, Serializer))
#define SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SERIALIZER, SerializerClass))
#define IS_SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SERIALIZER))
#define IS_SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SERIALIZER))
#define SERIALIZER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SERIALIZER, SerializerClass))

typedef struct _Serializer Serializer;
typedef struct _SerializerClass SerializerClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_EQUATION (equation_get_type ())
#define EQUATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EQUATION, Equation))
#define EQUATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EQUATION, EquationClass))
#define IS_EQUATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EQUATION))
#define IS_EQUATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EQUATION))
#define EQUATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EQUATION, EquationClass))

typedef struct _Equation Equation;
typedef struct _EquationClass EquationClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _EquationPrivate EquationPrivate;

#define TYPE_NUMBER (number_get_type ())
#define NUMBER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER, Number))
#define NUMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER, NumberClass))
#define IS_NUMBER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER))
#define IS_NUMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER))
#define NUMBER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER, NumberClass))

typedef struct _Number Number;
typedef struct _NumberClass NumberClass;

#define TYPE_ANGLE_UNIT (angle_unit_get_type ())

#define TYPE_ERROR_CODE (error_code_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_DISPLAY_FORMAT (display_format_get_type ())
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

typedef enum  {
	ANGLE_UNIT_RADIANS,
	ANGLE_UNIT_DEGREES,
	ANGLE_UNIT_GRADIANS
} AngleUnit;

struct _Equation {
	GObject parent_instance;
	EquationPrivate * priv;
	gint base;
	gint wordlen;
	AngleUnit angle_units;
};

struct _EquationClass {
	GObjectClass parent_class;
	gboolean (*variable_is_defined) (Equation* self, const gchar* name);
	Number* (*get_variable) (Equation* self, const gchar* name);
	void (*set_variable) (Equation* self, const gchar* name, Number* x);
	gboolean (*function_is_defined) (Equation* self, const gchar* name);
	Number* (*convert) (Equation* self, Number* x, const gchar* x_units, const gchar* z_units);
};

typedef enum  {
	ERROR_CODE_NONE,
	ERROR_CODE_INVALID,
	ERROR_CODE_OVERFLOW,
	ERROR_CODE_UNKNOWN_VARIABLE,
	ERROR_CODE_UNKNOWN_FUNCTION,
	ERROR_CODE_UNKNOWN_CONVERSION,
	ERROR_CODE_MP
} ErrorCode;

typedef enum  {
	DISPLAY_FORMAT_AUTOMATIC,
	DISPLAY_FORMAT_FIXED,
	DISPLAY_FORMAT_SCIENTIFIC,
	DISPLAY_FORMAT_ENGINEERING
} DisplayFormat;


extern Serializer* result_serializer;
Serializer* result_serializer = NULL;

#define MAXLINE 1024
GType serializer_get_type (void) G_GNUC_CONST;
void solve (const gchar* equation);
GType equation_get_type (void) G_GNUC_CONST;
Equation* equation_new (const gchar* expression);
Equation* equation_construct (GType object_type, const gchar* expression);
GType number_get_type (void) G_GNUC_CONST;
GType angle_unit_get_type (void) G_GNUC_CONST;
GType error_code_get_type (void) G_GNUC_CONST;
Number* equation_parse (Equation* self, guint* representation_base, ErrorCode* error_code, gchar** error_token, guint** error_start, guint** error_end);
void serializer_set_representation_base (Serializer* self, guint representation_base);
gchar* serializer_to_string (Serializer* self, Number* x);
gchar* mp_get_error (void);
gint _vala_main (gchar** args, int args_length1);
GType display_format_get_type (void) G_GNUC_CONST;
Serializer* serializer_new (DisplayFormat format, gint number_base, gint trailing_digits);
Serializer* serializer_construct (GType object_type, DisplayFormat format, gint number_base, gint trailing_digits);


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1282 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1282 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1282 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 139 "gcalccmd.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
#line 1284 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1284 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1284 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1284 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1284 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1284 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1284 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1284 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1284 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 170 "gcalccmd.c"
				goto __catch0_g_regex_error;
			}
#line 1284 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1284 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1284 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
			return NULL;
#line 179 "gcalccmd.c"
		}
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp6_ = regex;
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp7_ = replacement;
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp5_ = _tmp8_;
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 195 "gcalccmd.c"
				goto __catch0_g_regex_error;
			}
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
			return NULL;
#line 206 "gcalccmd.c"
		}
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp9_ = _tmp5_;
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_tmp5_ = NULL;
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		result = _tmp9_;
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_g_free0 (_tmp5_);
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1285 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		return result;
#line 220 "gcalccmd.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
#line 1283 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1283 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1287 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1283 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 234 "gcalccmd.c"
	}
	__finally0:
#line 1283 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1283 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1283 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1283 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
		return NULL;
#line 245 "gcalccmd.c"
	}
}


void solve (const gchar* equation) {
	gchar* tsep_string = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_ = NULL;
	gchar* decimal = NULL;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	Equation* e = NULL;
	const gchar* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	Equation* _tmp17_ = NULL;
	Equation* _tmp18_ = NULL;
	Equation* _tmp19_ = NULL;
	Equation* _tmp20_ = NULL;
	Equation* _tmp21_ = NULL;
	ErrorCode ret = 0;
	guint representation_base = 0U;
	Number* z = NULL;
	Equation* _tmp22_ = NULL;
	guint _tmp23_ = 0U;
	ErrorCode _tmp24_ = 0;
	Number* _tmp25_ = NULL;
	Serializer* _tmp26_ = NULL;
	guint _tmp27_ = 0U;
	Number* _tmp28_ = NULL;
#line 16 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	g_return_if_fail (equation != NULL);
#line 18 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp0_ = nl_langinfo (THOUSEP);
#line 18 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 18 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	tsep_string = _tmp1_;
#line 19 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp3_ = tsep_string;
#line 19 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	if (_tmp3_ == NULL) {
#line 19 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp2_ = TRUE;
#line 297 "gcalccmd.c"
	} else {
		const gchar* _tmp4_ = NULL;
#line 19 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp4_ = tsep_string;
#line 19 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") == 0;
#line 304 "gcalccmd.c"
	}
#line 19 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	if (_tmp2_) {
#line 308 "gcalccmd.c"
		gchar* _tmp5_ = NULL;
#line 20 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp5_ = g_strdup (" ");
#line 20 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_g_free0 (tsep_string);
#line 20 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		tsep_string = _tmp5_;
#line 316 "gcalccmd.c"
	}
#line 22 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp6_ = nl_langinfo (RADIXCHAR);
#line 22 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 22 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	decimal = _tmp7_;
#line 23 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp8_ = decimal;
#line 23 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	if (_tmp8_ == NULL) {
#line 328 "gcalccmd.c"
		gchar* _tmp9_ = NULL;
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp9_ = g_strdup ("");
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_g_free0 (decimal);
#line 24 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		decimal = _tmp9_;
#line 336 "gcalccmd.c"
	}
#line 26 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp10_ = equation;
#line 26 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp11_ = tsep_string;
#line 26 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp12_ = string_replace (_tmp10_, _tmp11_, "");
#line 26 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp13_ = _tmp12_;
#line 26 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp14_ = decimal;
#line 26 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp15_ = string_replace (_tmp13_, _tmp14_, ".");
#line 26 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp16_ = _tmp15_;
#line 26 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp17_ = equation_new (_tmp16_);
#line 26 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp18_ = _tmp17_;
#line 26 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_g_free0 (_tmp16_);
#line 26 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_g_free0 (_tmp13_);
#line 26 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	e = _tmp18_;
#line 27 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp19_ = e;
#line 27 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp19_->base = 10;
#line 28 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp20_ = e;
#line 28 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp20_->wordlen = 32;
#line 29 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp21_ = e;
#line 29 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp21_->angle_units = ANGLE_UNIT_DEGREES;
#line 33 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp22_ = e;
#line 33 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp25_ = equation_parse (_tmp22_, &_tmp23_, &_tmp24_, NULL, NULL, NULL);
#line 33 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	representation_base = _tmp23_;
#line 33 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	ret = _tmp24_;
#line 33 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	z = _tmp25_;
#line 35 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp26_ = result_serializer;
#line 35 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp27_ = representation_base;
#line 35 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	serializer_set_representation_base (_tmp26_, _tmp27_);
#line 36 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp28_ = z;
#line 36 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	if (_tmp28_ != NULL) {
#line 394 "gcalccmd.c"
		FILE* _tmp29_ = NULL;
		Serializer* _tmp30_ = NULL;
		Number* _tmp31_ = NULL;
		gchar* _tmp32_ = NULL;
		gchar* _tmp33_ = NULL;
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp29_ = stdout;
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp30_ = result_serializer;
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp31_ = z;
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp32_ = serializer_to_string (_tmp30_, _tmp31_);
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp33_ = _tmp32_;
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		fprintf (_tmp29_, "%s\n", _tmp33_);
#line 37 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_g_free0 (_tmp33_);
#line 414 "gcalccmd.c"
	} else {
		ErrorCode _tmp34_ = 0;
#line 38 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp34_ = ret;
#line 38 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		if (_tmp34_ == ERROR_CODE_MP) {
#line 421 "gcalccmd.c"
			FILE* _tmp35_ = NULL;
			gchar* _tmp36_ = NULL;
			gchar* _tmp37_ = NULL;
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp35_ = stderr;
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp36_ = mp_get_error ();
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp37_ = _tmp36_;
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			fprintf (_tmp35_, "Error %s\n", _tmp37_);
#line 39 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_g_free0 (_tmp37_);
#line 435 "gcalccmd.c"
		} else {
			FILE* _tmp38_ = NULL;
			ErrorCode _tmp39_ = 0;
#line 41 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp38_ = stderr;
#line 41 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp39_ = ret;
#line 41 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			fprintf (_tmp38_, "Error %d\n", (gint) _tmp39_);
#line 445 "gcalccmd.c"
		}
	}
#line 16 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_g_object_unref0 (z);
#line 16 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_g_object_unref0 (e);
#line 16 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_g_free0 (decimal);
#line 16 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_g_free0 (tsep_string);
#line 456 "gcalccmd.c"
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 1115 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1116 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1116 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1117 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1117 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1118 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	result = _result_;
#line 1118 "/home/mcatanzaro/jhbuild/install/share/vala-0.28/vapi/glib-2.0.vapi"
	return result;
#line 479 "gcalccmd.c"
}


gint _vala_main (gchar** args, int args_length1) {
	gint result = 0;
	GDateTime* now = NULL;
	GDateTime* _tmp0_ = NULL;
	gboolean requires_new_line = FALSE;
	GDateTime* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	Serializer* _tmp3_ = NULL;
	gchar* buffer = NULL;
	gchar* _tmp4_ = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	gboolean _tmp21_ = FALSE;
#line 47 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp0_ = g_date_time_new_now_utc ();
#line 47 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	now = _tmp0_;
#line 48 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	requires_new_line = FALSE;
#line 50 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp1_ = now;
#line 50 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp2_ = g_date_time_get_microsecond (_tmp1_);
#line 50 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	g_random_set_seed ((guint32) _tmp2_);
#line 52 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	setlocale (LC_ALL, "");
#line 54 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp3_ = serializer_new (DISPLAY_FORMAT_AUTOMATIC, 10, 9);
#line 54 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_g_object_unref0 (result_serializer);
#line 54 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	result_serializer = _tmp3_;
#line 56 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp4_ = g_new0 (gchar, 1024);
#line 56 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	buffer = _tmp4_;
#line 56 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	buffer_length1 = 1024;
#line 56 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_buffer_size_ = buffer_length1;
#line 57 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	while (TRUE) {
#line 526 "gcalccmd.c"
		FILE* _tmp5_ = NULL;
		gchar* line = NULL;
		FILE* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gint _tmp7__length1 = 0;
		const gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		const gchar* _tmp16_ = NULL;
		const gchar* _tmp20_ = NULL;
#line 59 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp5_ = stdout;
#line 59 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		fprintf (_tmp5_, "> ");
#line 60 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp6_ = stdin;
#line 60 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp7_ = buffer;
#line 60 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp7__length1 = buffer_length1;
#line 60 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp8_ = fgets (_tmp7_, _tmp7__length1, _tmp6_);
#line 60 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 60 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		line = _tmp9_;
#line 62 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp10_ = line;
#line 62 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		if (_tmp10_ != NULL) {
#line 560 "gcalccmd.c"
			const gchar* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
#line 63 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp11_ = line;
#line 63 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp12_ = string_strip (_tmp11_);
#line 63 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_g_free0 (line);
#line 63 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			line = _tmp12_;
#line 571 "gcalccmd.c"
		} else {
#line 65 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			requires_new_line = TRUE;
#line 575 "gcalccmd.c"
		}
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp16_ = line;
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		if (_tmp16_ == NULL) {
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp15_ = TRUE;
#line 583 "gcalccmd.c"
		} else {
			const gchar* _tmp17_ = NULL;
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp17_ = line;
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp15_ = g_strcmp0 (_tmp17_, "exit") == 0;
#line 590 "gcalccmd.c"
		}
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		if (_tmp15_) {
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp14_ = TRUE;
#line 596 "gcalccmd.c"
		} else {
			const gchar* _tmp18_ = NULL;
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp18_ = line;
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp14_ = g_strcmp0 (_tmp18_, "quit") == 0;
#line 603 "gcalccmd.c"
		}
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		if (_tmp14_) {
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp13_ = TRUE;
#line 609 "gcalccmd.c"
		} else {
			const gchar* _tmp19_ = NULL;
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp19_ = line;
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_tmp13_ = g_strcmp0 (_tmp19_, "") == 0;
#line 616 "gcalccmd.c"
		}
#line 67 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		if (_tmp13_) {
#line 68 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			_g_free0 (line);
#line 68 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
			break;
#line 624 "gcalccmd.c"
		}
#line 70 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp20_ = line;
#line 70 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		solve (_tmp20_);
#line 57 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_g_free0 (line);
#line 632 "gcalccmd.c"
	}
#line 73 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_tmp21_ = requires_new_line;
#line 73 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	if (_tmp21_) {
#line 638 "gcalccmd.c"
		FILE* _tmp22_ = NULL;
#line 74 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		_tmp22_ = stdout;
#line 74 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
		fprintf (_tmp22_, "\n");
#line 644 "gcalccmd.c"
	}
#line 76 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	result = EXIT_SUCCESS;
#line 76 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	buffer = (g_free (buffer), NULL);
#line 76 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	_g_date_time_unref0 (now);
#line 76 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	return result;
#line 654 "gcalccmd.c"
}


int main (int argc, char ** argv) {
#if !GLIB_CHECK_VERSION (2,35,0)
	g_type_init ();
#endif
#line 44 "/home/mcatanzaro/jhbuild/checkout/gnome-calculator/src/gcalccmd.vala"
	return _vala_main (argv, argc);
#line 664 "gcalccmd.c"
}



